<?php
/**
 *
 * @version		2.0.4
 * @package		none
 * @copyright	Copyright (C) 2008-2009-2010 Cedric Walter from www.waltercedric.com. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 *
 * relatedArticles is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.

 * Author: Cedric Walter
 * Email: cedric.walter@gmail.com
 * Web: http://www.waltercedric.com
 *
 **/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
require_once(dirname( __FILE__ ).DS.'relatedThumbArticles'.DS.'relatedThumbItems.class.php');

class plgContentRelatedThumbArticles extends JPlugin
{
	function plgContentRelatedThumbArticles( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		$plugin =& JPluginHelper::getPlugin('content', 'relatedThumbArticles');
		$pluginParams 	= new JParameter( $plugin->params );
		$this->debug= $pluginParams->get('debug','1');
	}

	var $debug = true;


	function onPrepareContent( &$article, &$params, $limitstart )
	{
		global $access, $mainframe, $task, $Itemid, $mosConfig_offset, $option;
		$plugin =& JPluginHelper::getPlugin('content', 'relatedThumbArticles');
		$pluginParams 	= new JParameter( $plugin->params );

		//optimization, escape fast
		if (!$pluginParams->get('enabled', 1)) {
			return true;
		}

		$RelatedArticles = new RelatedArticles($pluginParams);
		$RelatedArticles->log('Plugin plgRelatedArticles is enable');

		if ($RelatedArticles->articleMatch($article->secid,$article->catid) == false)
		{
			$RelatedArticles->log('Current articleID'.$article->id.' is in a categoryID '.$article->catid.' that you decide to exclude in settings');
			return true;
		}

		$view		= JRequest::getCmd('view');
		if ($option=='com_content' AND ($view == 'article'))
		{
			$RelatedArticles->log('Plugin plgRelatedArticles has some work to do');
			JPlugin::loadLanguage( 'plg_content_relatedarticles' );

			$listitems = $RelatedArticles->getListItems($article->id, $article->catid, $access);

			//positionning of related article
			$param_position = intval( $pluginParams->get( 'position', 1 ) );
			if ($param_position == "0") {
				//before current article
				$article->text = $listitems.$article->text;
			} else {
				//after current article
				$article->text = $article->text.$listitems;
			}
		}

		return true;
	}
}
?>