<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


define('_RELATEDARTICLES_HORIZONTAL_CSS','plugins/content/relatedThumbArticles/horizontal.css');
define('_RELATEDARTICLES_VERTICAL_CSS','plugins/content/relatedThumbArticles/vertical.css');

jimport('joomla.error.log');

class RelatedArticles extends JObject {

	var $nowdate = null;

	/** instance of JLog */
	var $logger = null;
	var $debug = true;
	var $useThumbnails= null;
	var $textbefore= null;
	var $date_format= null;
	var $showDateInDays = null;
	var $showDate= null;
	var $style = null;
	var $thumbnailWidth= null;
	var $thumbnailHeight= null;
	var $descriptionLength = null;
	var $backlink= null;
	var $textafter= null;
	var $orderby =  null;
	var $orderby2=  null;
	var $limit =  null;
	var $image = null;

	//array of user selected sectionid
	var $selectedSectionID = null;

	//array of user selected categories
	var $selectedCategoryID	= null;


	/**
	 * Constructor
	 * @return unknown_type
	 */
	function RelatedArticles($pluginParams) {
		$JConfig = new JConfig;
		$this->nowdate = date( 'Y-m-d H:i:s', time()+$JConfig->offset*60*60 );


		$options = array(
            'format' => "{DATE}\t{TIME}\t{COMMENT}"
            );
            // Create the instance of the log file in case we use it later
            $this->logger = &JLog::getInstance('plg_relatedThumbArticles.php', $options);


            $this->useThumbnails= intval($pluginParams->get('useThumbnails',1));
            $this->textbefore= $pluginParams->get('textbefore','Another articles:');
            $this->date_format= $pluginParams->get('date_format','%Y-%m-%d');
            $this->showDateInDays = intval( $pluginParams->get( 'showDateInDays', 1 ) );
            $this->showDate= $pluginParams->get('showDate','1');
            $this->style= $pluginParams->get('style','1');
            $this->thumbnailWidth= $pluginParams->get('thumbnailWidth','70');
            $this->thumbnailHeight= $pluginParams->get('thumbnailHeight','70');
            $this->descriptionLength = $pluginParams->get('DescriptionLength','100');
            $this->backlink= $pluginParams->get('backlink','1');
            $this->textafter= $pluginParams->get('textafter','');
            $this->orderby = intval( $pluginParams->get('orderby','0') );
            $this->orderby2= intval( $pluginParams->get('orderby2','0') );
            $this->limit = intval( $pluginParams->get( 'limit', 10 ) );
            $this->image= $pluginParams->get('defaultImage',"/plugins/content/relatedArticles/default.jpg");

            $this->selectedSectionID = $pluginParams->get('secid');
            $this->selectedCategoryID		=   $pluginParams->get('includedCatIds');
	}

	function articleMatch ($articleSectionID,$articleCategoryID ) {
		$this->log('$selectedCategoryID '.$this->selectedCategoryID . ' articleCategoryID '.$articleCategoryID);
		$match = (is_array($this->selectedCategoryID)) ? in_array($articleCategoryID,$this->selectedCategoryID) : strcmp(trim($this->selectedCategoryID), $articleCategoryID) == 0;

		return $match;
	}

	function getListItems($articleId, $categoryId, $access ) {
		$listitems = "";

		$rows = $this->getRelatedArticles($articleId, $categoryId, $access);

		$this->log("Found ".sizeof($rows)." related articles");
		//if we have something to do
		if ($rows){
			$this->addStyleSheet();

			$uri    = JURI::getInstance();
			$prefix = $uri->toString(array('scheme', 'host', 'port'));

			//start HERE
			$listitems = "<div><div class='relatedArticles_textBefore'><h3>".$this->textbefore."</h3></div>";
			$listitems .= "
					 <div id='relatedArticles' style='border: 0pt none ; margin: 0pt; padding: 0pt; clear: both;'><div id='relatedArticles_rl1'></div>
		 			 <ul class='relatedArticles_ul_list' style='list-style-type: none;'>";

			$JConfig = new JConfig;
			foreach ( $rows as $row2 ) {
				$row2->created = JHTML::_('date', $row2->created, $this->date_format);
				$url = str_replace('&amp;', '&',ContentHelperRoute::getArticleRoute( $row2->slug, $row2->catslug, $row2->sectionid));
				$sefurl		= $uri->toString( array('scheme', 'host', 'port')).JRoute::_($url);

				$description = $this->getDescription($row2->introtext, $row2->fulltext);
				$image = $this->getImage($row2->introtext);

				$link = $JConfig->sef ? $sefurl : $url;
				$listitems .= $this->addEntry($row2->title, $link, $description, $image, $row2->created);
			}
			$listitems .= "</ul>";
			$listitems .= "</div>"; //end relatedArticle
			$listitems .= $this->addFooter();
			$listitems .= "</div>"; //end
		}
		return $listitems;
	}


	/**
	 * Calculate the differences between today ar article post
	 * return either 2009.12.24 or 15 days ago
	 *
	 * @param $articleDate
	 * @return unknown_type
	 */
	function addDate($articleDate) {
		$listitems = "";
		if ($this->showDate)
		{
			if ($this->showDateInDays)
			{
				$listitems .= "<br />".$this->dateDiff($articleDate, $this->nowdate)." days ago";
			}
			else
			{
				$listitems .= $articleDate;
			}
		}

		return $listitems;
	}

	/**
	 * Add the correct stylesheet to html head
	 * @return unknown_type
	 */
	function addStyleSheet()  {
		$document =& JFactory::getDocument();
		if ($this->style)
		{
			$document->addStyleSheet(_RELATEDARTICLES_HORIZONTAL_CSS);
		}
		else
		{
			$document->addStyleSheet(_RELATEDARTICLES_VERTICAL_CSS);
		}
	}

	/**
	 * remove all html tags and return a truncate text of introtext
	 * @param unknown_type $introtext
	 * @param unknown_type $fulltext
	 * @return unknown_type
	 */
	function getDescription($introtext, $fulltext)
	{
		//strip all HTML tags, not invalid html code may lead to text truncated
		$introtext = strip_tags($introtext);
		$introtext = substr($introtext, 0 , $this->descriptionLength);

		return $introtext;
	}


	function addFooter() {
		$footer = '<div>'.$this->textafter.'</div>';

		//Please keep this link,
		//consider a donation if you would like to remoe, youre not forced to donate!
		//backlink is my only salary
		$footer .= "<center><a href='http://www.waltercedric.com/'>relatedArticles</a></center>";

		return $footer;
	}

	function addEntry($title, $link, $description, $image, $articleDate) {
		$entry = "<li id='relatedArticles_li' style='height: 74px;'>
             <div id='relatedArticles_image'>
             <a href='".$link."' target='_top'>";

		if ($image != null)
		{
			$entry .= "<img id='relatedArticles_thumb' src='".JURI :: base()."/plugins/content/relatedThumbArticles/timthumb.php?src=".$image."&amp;w=".$this->thumbnailWidth."&amp;h=".$this->thumbnailHeight."&amp;zc=1'></a></div>";
		}
			
		$entry .=   "<div id='relatedArticles_title'><a href='".$link."' target='_top'>".$title."</a></div>
		<div id='description'>".$description."...</div><div id='date'>".$this->addDate($articleDate)."</div>
		</li>";

		return $entry;
	}


	/**
	 * Try to extract the first images from $fulltext, if not found return a default
	 *
	 * @param $fulltext
	 * @return unknown_type
	 */
	function getImage($html) {
		//escape fast
		if (!$this->useThumbnails)
		{
			return null;
		}
		//default
		$image= $this->image;
		//cant use a DOM XML parser, not all code is XHTML, do a string index of before a regexp which cost more time
		if (strpos($html, "img")) {
			//$pattern = "/img.*src=[\"']?([^\"']?.*)[\"']?/i";
			$pattern = "/\<img.+?src=\"(.+?)\".+?\/>/";
			preg_match_all($pattern, $html, $images);
			$image = $images[1][0];

			/*if (!file_exists(JPATH_SITE.$image))
			 {
			 }
			 */
		}

		return $image;
	}

	function getSQL($articleID, $categoryID, $access) {
		$orderbysql = "id";
		if($this->orderby=="1"){
			$orderbysql = "created";
		}elseif($this->orderby == "2"){
			$orderbysql = "title";
		}

		$orderbysql .= " DESC";
		if($this->orderby2 == "1"){
			$orderbysql .= " ASC";
		}

		$user	=& JFactory::getUser();

		// Get next xx article from Contents
		$query = 'SELECT a.id, a.title, a.created, a.introtext, a.fulltext, '
		. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'
		. ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(":", b.id, b.alias) ELSE b.id END as catslug,'
		. ' u.id AS sectionid'
		. ' FROM #__content as a'
		. ' INNER JOIN #__categories AS b ON b.id=a.catid'
		. ' INNER JOIN #__sections AS u ON u.id = a.sectionid'
		. ' WHERE ( state = \'1\' AND a.checked_out = 0 )'
		. ' AND a.state = 1'
		. ' AND u.published = 1'
		. ' AND b.published = 1'
		. ' AND ( publish_up = \'0000-00-00 00:00:00\' OR publish_up <= \''. $this->nowdate .'\' )'
		. ' AND ( publish_down = \'0000-00-00 00:00:00\' OR publish_down >= \''. $this->nowdate .'\' )'
		. ( $access ? '\n AND access <= \''.$user->gid.'\'' : '' )
		. ' AND catid = '. (int) $categoryID
		. ' AND a.id != '. (int) $articleID
		. ' ORDER BY '.$orderbysql
		. ' LIMIT '.$this->limit;
		$this->log($query);
		return $query;
	}


	function getRelatedArticles($articleID, $categoryID, $access) {
		$database = & JFactory::getDBO();
		$database->setQuery( $this->getSQL($articleID, $categoryID, $access) );

		$rows = $database->loadObjectList();
		return $rows;
	}


	function log($comment) {
		if ($this->debug)
		{
			$this->logger->addEntry(array('comment' => $comment));
		}
	}

	/**
	 * Finds the difference in days between two calendar dates. require PHP 5.1 at least
	 *
	 * @param Date $startDate
	 * @param Date $endDate
	 * @return Int
	 */
	function dateDiff($startDate, $endDate)
	{
		if (function_exists('gregoriantojd'))
		{
			// Parse dates for conversion
			$startArry = date_parse($startDate);
			$endArry = date_parse($endDate);

			// Convert dates to Julian Days
			$start_date = gregoriantojd($startArry["month"], $startArry["day"], $startArry["year"]);
			$end_date = gregoriantojd($endArry["month"], $endArry["day"], $endArry["year"]);

			// Return difference
			return round(($end_date - $start_date), 0);
		}
		else
		{
			//the one above is better!
			$d1 = strtotime($startDate);
			$d2 = strtotime($endDate);
			$delta = $d2 - $d1;
			return  round($delta / 86400);
			//return "<font color='red'>function gregoriantojd() do not exist! upgrade to php 5.1 or use in relatedArticles admin panel showDateInDays = NO as a workaround</font>";
		}
	}
}